package ex02

import java.nio.file.Files

import org.scalatest.{FlatSpec, Matchers}


class InMemorySerializerTest extends FlatSpec with Matchers {

  "deserialize after serialize" should "contain serialized entry" in {
    val fs = new InMemorySerializer {}

    fs.serialize("test1", 42, "truth")
    fs.deserialize("test1").last._2 should equal (42)
  }

  "desiralize for one name" should "not affect others" in {
    val fs = new InMemorySerializer {}

    fs.serialize("test1", 42, "truth")
    fs.deserialize("test2").isEmpty should be (true)
  }
}
